chiark / gitweb /
Manual improvements. Check that we are delegated to if we want to be.
[chiark-utils.git] / scripts / named-conf
index b037492..a6d7df8 100755 (executable)
@@ -1,34 +1,51 @@
 #!/usr/bin/perl -w
 
+use strict;
 use IO::File;
 use Data::Dumper;
 
-$etcfile= "/etc/bind/chiark-conf-gen.zones";
-$where= '<built-in>';
+use vars qw($quis
+           $mode $doall
+           $etcfile $where
+           $debug $needglue $localonly $verbosity);
+
+$quis= $0; $quis =~ s,.*/,,;
 
 $mode= '';
+$doall= 0;
+$etcfile= "/etc/bind/chiark-conf-gen.zones";
+$where= '<built-in>';
+$debug= 0;
+$needglue= 2;
+$localonly= 0;
 $verbosity= 1;
-$fromroot= 0;
+
+use vars qw($dig_owner $dig_type $dig_rdata);
 
 while (@ARGV && $ARGV[0] =~ m/^\-/) {
     $_= shift @ARGV;
     if (s/^\-\-//) {
        last if m/^$/;
-       if (m/^quiet$/) { $verbosity=0; }
-       elsif (m/^verbose$/) { $verbosity=2; }
-       elsif (m/^root$/) { $fromroot=1; }
-       elsif (m/^(yes|no|force)$/) { m/^./; $mode= $&; }
+       if (m/^(yes|no|force)$/) { m/^./; $mode= $&; }
+       elsif (m/^all$/) { $doall=1; }
        elsif (m/^config$/) { $etcfile= loarg(); $where= '--config option'; }
+       elsif (m/^glueless$/) { $needglue--; }
+       elsif (m/^localonly$/) { $localonly=1; }
+       elsif (m/^quiet$/) { $verbosity=0; }
+       elsif (m/^verbose$/) { $verbosity=2; }
        else { usageerr("unknown option --$_"); }
     } else {
        s/^\-//;
        last if m/^$/;
        while (m/^./) {
            if (s/^[ynf]//) { $mode=$&; }
-           elsif (s/^r//) { $fromroot=1; }
-           elsif (s/^v//) { $verbosity=2; }
-           elsif (s/^q//) { $verbosity=0; }
+           elsif (s/^A//) { $doall=1; }
            elsif (s/^C//) { $etcfile= soarg(); $where= '-C option'; }
+           elsif (s/^D//) { $debug++; }
+           elsif (s/^g//) { $needglue--; }
+           elsif (s/^l//) { $localonly=1; }
+           elsif (s/^q//) { $verbosity=0; }
+           elsif (s/^v//) { $verbosity=2; }
            else { usageerr("unknown option -$&"); }
        }
     }
@@ -37,6 +54,8 @@ while (@ARGV && $ARGV[0] =~ m/^\-/) {
 sub loarg() { usageerr("missing option value") if !@ARGV; return shift @ARGV; }
 sub soarg() { my ($rv); $rv=$_; $_=''; return length $rv ? $rv : loarg(); }
 
+usageerr("-g may be specified at most twice") if $needglue<0;
+usageerr("-D may be specified at most twice") if $debug>2;
 usageerr("must specify either -f|-y|-n or zones (and not both)")
     if !!$mode == !!@ARGV;
 
@@ -49,7 +68,6 @@ usage: named-conf-regen [-rvq] -f|-y|-n|<zone>...\n".
 " -y --yes     check and install\n".
 " -n --no      check only\n".
 "additional options:\n".
-" -r --root    check all the way back to the root\n".
 " -q --quiet   no output for OK zones\n".
 " -v --verbose extra verbose\n";
 }
@@ -57,29 +75,46 @@ usage: named-conf-regen [-rvq] -f|-y|-n|<zone>...\n".
 cfg_fail("config filename $etcfile should have been absolute path of a file")
     unless $etcfile =~ m,^/, && $etcfile !~ m,/$,;
 
+use vars qw($default_dir);
 $default_dir= $etcfile;
 $default_dir =~ s,/[^/]+$,,;
 
+use vars qw($slave_dir $slave_prefix $slave_suffix);
 $slave_dir= 'slave';
 $slave_prefix= '';
 $slave_suffix= '';
-@self_ns= @self_soa= ();
+
+use vars qw(@self_ns @self_soa @self_addr);
+@self_ns= @self_soa= @self_addr= ();
+
+use vars qw(%zone_cfg @zone_cfg_list);
 %zone_cfg= ();
 @zone_cfg_list= ();
+
+use vars qw($output $default_output %output_contents);
 $output= '';
 $default_output= '';
 %output_contents= ();
 
+use vars qw($check $install);
+$check= $mode !~ m/^f/;
+$install= $mode =~ m/^[yf]/;
+
 read_config($etcfile);
+debug_dump('@zone_cfg_list %zone_cfg');
+process_zones($mode ? @zone_cfg_list : @ARGV);
+debug_dump('%output_contents');
+
+exit 0;
 
-print Dumper(@zone_cfg_list), Dumper(%zone_cfg);
+#-------------------- configuration reading
 
-sub cfg_fail ($) { die "$0: $where:\n $_[0]\n"; }
+sub cfg_fail ($) { die "$quis: $where:\n $_[0]\n"; }
 
 sub read_config ($) {
     my ($if) = @_;
-    my ($fh,$z,@self, $dir,$prefix,$suffix,$lprefix,$lsuffix);
-    local ($_,$1,$2,$3);
+    my ($fh,$z,@self, $mod,$dir,$prefix,$suffix,$lprefix,$lsuffix);
+    local ($_);
 
     $fh= new IO::File $if,'r' or cfg_fail("open $if:\n $!");
     for (;;) {
@@ -96,28 +131,30 @@ sub read_config ($) {
            @self= split /\s+/, $2;
            @self_ns= @self if $1 ne '-soa';
            @self_soa= @self if $1 ne '-ns';
-       } elsif (m/^primary\-dir\s+(\S+)((?:\s+(\S+))??:\s+(\S+))?$/) {
-           ($dir, $prefix, $suffix) = (qualify($1),$2,$3);
-           $suffix= '_db' if !length $suffix;
+       } elsif (m/^self\-addr\s+([0-9. \t]+)/) {
+           @self_addr= split /\s+/, $1;
+       } elsif (m/^primary\-dir([*?]?)\s+(\S+)((?:\s+(\S+))?:\s+(\S+))?$/) {
+           ($mod, $dir, $prefix, $suffix) = ($1,qualify($2),$3,$4);
+           $suffix= '_db' if !defined $suffix;
+           $prefix= '' if !defined $prefix;
            opendir D, $dir or cfg_fail("open primary-dir $dir:\n $!");
            $lprefix= length $prefix; $lsuffix= length $suffix;
-           while ($!=0, $_= readdir D) {
+           while (defined($_= readdir D)) {
                next if m/^\./ && !$lprefix;
                next unless length > $lprefix+$lsuffix;
                next unless substr($_,0,$lprefix) eq $prefix;
                next unless substr($_,length($_)-$lsuffix) eq $suffix;
                $z= substr($_,$lprefix,length($_)-($lprefix+$lsuffix));
-               zone_conf($z,'primary',"$dir/$_");
+               zone_conf($z,'primary','p',$mod,"$dir/$_");
            }
-           $! and cfg_fail("read primary-dir $dir:\n $!");
            closedir D or cfg_fail("close primary-dir $dir:\n $!");
-       } elsif (m/^primary\s+(\S+)\s+(\S+)$/) {
-           zone_conf($1,'primary',qualify($2));
-       } elsif (m/^secondary\s+(\S+)\s+([0-9.\t]+)$/) {
-           zone_conf($1,'secondary','',$2);
-       } elsif (m/^stealth\s+(\S+)\s+([0-9. \t]+)$/) {
-           zone_conf($1,'stealth','',split /\s+/, $2);
-       } elsif (m/^slave\-dir\s+(\S+)((?:\s+(\S+))??:\s+(\S+))?$/) {
+       } elsif (m/^primary([*?]?)\s+(\S+)\s+(\S+)$/) {
+           zone_conf($2,'primary','p',$1,qualify($3));
+       } elsif (m/^published([*?]?)\s+(\S+)\s+([0-9.\t]+)$/) {
+           zone_conf($2,'published','s',$1,'',$3);
+       } elsif (m/^stealth([*?]?)\s+(\S+)\s+([0-9. \t]+)$/) {
+           zone_conf($2,'stealth','u',$1,'',split /\s+/, $3);
+       } elsif (m/^slave\-dir\s+(\S+)((?:\s+(\S+))?:\s+(\S+))?$/) {
            ($slave_dir, $slave_prefix, $slave_suffix) = (qualify($1),$2,$3);
        } elsif (m/^output\s+bind8\+(\S+)$/) {
            cfg_fail("default output may not apply to only some zones")
@@ -136,10 +173,12 @@ sub read_config ($) {
 sub qualify ($) {
     my ($i) = @_;
     $i= "$default_dir/$i" unless $i =~ m,^/,;
+    return $i;
 }
 
-sub zone_conf ($$@) {
-    my ($zone,$style,$file,@servers) = @_;
+sub zone_conf ($$$$$@) {
+    my ($zone,$style,$sabbr,$mod,$file,@servers) = @_;
+    my ($sfx,$aref);
     $file= qualify("$slave_dir/$slave_prefix".$zone.$slave_suffix)
        unless length $file;
     if (!length $output) {
@@ -149,8 +188,14 @@ sub zone_conf ($$@) {
     }
     cfg_fail("redefined zone $zone") if exists $zone_cfg{$zone};
     $zone_cfg{$zone}{'file'}= $file;
-    $zone_cfg{$zone}{'style'}= $style;
-    $zone_cfg{$zone}{'servers'}= @servers;
+    $zone_cfg{$zone}{'style_p'}= $style.$mod;
+    $zone_cfg{$zone}{'s'}= $sabbr.$mod; # p)rimary s)econdary u)npub f)oreign
+    $zone_cfg{$zone}{'servers'}= [ @servers ];
+    foreach $sfx (qw(soa ns addr)) {
+       { no strict 'refs'; $aref= [ @{ "self_$sfx" } ]; }
+       @$aref or cfg_fail("failed to specify self-$sfx before zone");
+       $zone_cfg{$zone}{"self_$sfx"}= $aref;
+    }
     $zone_cfg{$zone}{'output'}= $output;
     push @zone_cfg_list, $zone;
 }
@@ -161,233 +206,416 @@ sub set_output($) {
     $output_contents{$output}= '';
 }
 
-__DATA__
 
+#-------------------- checking
 
+use vars qw($zone $cfg $warnings);
+$warnings= 0;
 
-sub lookup ($$) {
-    my ($type,$domain) = @_;
-    my ($c,@result);
-    defined($c=open ADH, "-|") or die "$0: fork adnshost:\n $!\n";
-    if (!$c) {
-       exec 'adnshost','+Do','+Dt','+Dc','-Cf',"-t$type",
-            '-',"$domain.";
-       die "$0: exec adnshost:\n $!\n";
+sub progress ($) {
+    return if !$verbosity;
+    print "$_[0]\n";
+}
+
+sub verbose ($) {
+    return if $verbosity<2;
+    print "    $_[0]\n";
+}
+
+sub process_zones (@) {
+    my (@zones) = @_;
+    local ($zone,$cfg);
+
+    foreach $zone (@zones) {
+       $cfg= $zone_cfg{$zone} || {
+           'style_p' => 'foreign',
+           's' => 'f',
+           'servers' => [ ],
+           };
+       progress(sprintf "%-40s %s", $zone, $$cfg{'style_p'});
+       if ($check && ($doall || $cfg->{'s'} !~ m/\?/)) {
+           eval {
+               if ($localonly && $cfg->{'s'} =~ m/f/) {
+                   zone_warning("foreign zone specified with -l");
+               } elsif ($cfg->{'s'} =~ m/\*/ ||
+                        ($localonly && $cfg->{'s'} !~ m/p/)) {
+                   zone_check_local();
+               } else {
+                   zone_check_full();
+               }
+           };
+           zone_warning("checks failed: $@") if length $@;
+       }
+       zone_output() if $install;
     }
-    @result= <ADH>;
-    chomp @result;
-    $!=0; close ADH;
-    die "$0: lookup -t$type $domain failed $? $!\n" if $? or $!;
-    return @result;
+    print STDERR "$quis: $warnings warnings\n" or die $!
+       if $warnings;
 }
 
-sub lookup1 ($$) {
-    my ($type,$domain) = @_;
-    my (@result)= lookup($type,$domain);
-    @result==1 or die "$0: lookup -t$type $domain gave more than one RR\n";
-    return $result[0];
+sub zone_warning ($) {
+    my ($w) = @_;
+    $w =~ s/\n$//;
+    $w =~ s,\n, // ,g;
+    print STDERR "$zone: warning: $w\n" or die $!;
+    $warnings++;
 }
 
-sub check () {
-    return unless $check;
-    eval {
-       $soa= lookup1('soa',$zone);
-       $soa_origin=$soa; $soa_origin =~ s/ .*//;
-       $soa_origin_addr= lookup1('a',$soa_origin);
+sub zone_warnmore ($) {
+    print STDERR " $_[0]\n" or die $!;
+}
+
+use vars qw(%delgs); # $delgs{$nameserver_list} = [ $whosaidandwhy ]
+use vars qw(%auths); # $auths{$nameserver_list} = [ $whosaidandwhy ]
+use vars qw(%glue);  # $glue{$name}{$addr_list} = [ $whosaidandwhy ]
+use vars qw(%soas);  # $soa{"$origin $serial"} = [ $whosaidandwhy ]
+use vars qw(%addr_is_ok %warned_glueless %warned_mynameaddr);
+use vars qw($delg_to_us);
+use vars qw(@to_check); # ($addr,$whyask,$is_auth,$glueless_ok, ...)
+use vars qw(@to_check_soa); # ($addr,$whyask, ...)
+
+sub zone_check_full () {
+    zone_reset();
+    zone_investigate();
+    zone_consistency();
+    zone_servers_ok();
+}
 
-       @zone_ns= lookup('ns-',$zone);
+sub zone_reset() {
+    %delgs= %auths= %glue= %soas=
+       %warned_glueless= %warned_mynameaddr=
+           %addr_is_ok= ();
+    $delg_to_us= 0;
+    @to_check= @to_check_soa= ();
+}
 
-       @ok_sources= ($soa_origin_addr);
-       $ok_sources_descr= "SOA ORIGIN $soa_origin [$soa_origin_addr]";
+sub zone_investigate() {
+    my ($super_zone, @super_nsnames,
+       $super_ns, @super_ns_addrs, $s, $wa, $is_auth,
+       %nsrrset_checked, %soa_checked, $addr, $glueless_ok, $rcode);
 
-       if ($style eq 'unoff' || $style eq 'backup') {
-           for $zone_ns (@zone_ns) {
-               @zone_ns_addrs= lookup('a',$zone_ns);
-               push @ok_sources, @zone_ns_addrs;
-               $ok_sources_descr.= ", NS $zone_ns [@zone_ns_addrs]";
-           }
+    $super_zone= $zone;
+    for (;;) {
+       debug_trace("zone $zone superzone $super_zone");
+       $super_zone =~ s/^[^.]+\.// or die "no superzone ? ($super_zone)\n";
+       ($rcode,@super_nsnames)= lookup($super_zone,'ns-','06');
+       last if !$rcode;
+    }
+    for $super_ns (@super_nsnames) {
+       $super_ns= lc $super_ns;
+       ($rcode,@super_ns_addrs)= lookup($super_ns,'a','0');
+       foreach $addr (@super_ns_addrs) {
+           push @to_check,
+                $addr,
+                "$super_ns, server for $super_zone",
+                0, 0;
        }
+    }
+    for (;;) {
+       # We do these in order so that we always do NS RRset checks on
+       # nameservers that came from other NS RRsets first; otherwise
+       # we might set nsrrset_checked due to a glueless_ok check,
+       # and then not check for gluefulness later.
+       debug_dump('@to_check @to_check_soa');
+       if (($addr,$wa,$is_auth,$glueless_ok,@to_check) = @to_check) {
+           push @to_check_soa, $addr, $wa if $is_auth;
+           next if $nsrrset_checked{$addr}++;
+           zone_check_nsrrset($addr, "[$addr] $wa",
+                              $is_auth, $glueless_ok);
+       } elsif (($addr,$wa,@to_check_soa) = @to_check_soa) {
+           next if $soa_checked{$addr}++;
+           zone_check_soa($addr,"[$addr] $wa","[$addr] NS");
+       } else {
+           last;
+       }
+    }
+}
 
-       for $server (@servers) {
-           grep { $server eq $_ } @ok_sources
-               or warn "secondarying from $server which is not ".
-                       "$ok_sources_desc\n";
+sub zone_check_nsrrset ($$$$) {
+    my ($uaddr,$ww, $is_auth, $glueless_ok) = @_;
+    my (@s, $s, %s2g, @glue, $glue, $delgs_or_auths, $wwn);
+    verbose("checking delegation by $ww");
+    dig(sub {
+       if ($dig_type eq 'ns' && $dig_owner eq $zone) {
+           $s2g{lc $dig_rdata} = [ ];
+       } elsif ($dig_type eq 'a' && exists $s2g{$dig_owner}) {
+           $wwn= "in glue from $ww";
+           push @to_check, $dig_rdata, "$dig_owner, $wwn", 1, 0;
+           zone_server_addr($dig_rdata,$dig_owner,$wwn,"NS [$uaddr]",0);
+           push @{ $s2g{$dig_owner} }, $dig_rdata;
+       }
+    },
+            $zone,'ns',$uaddr);
+    if (!%s2g) { zone_warning("unable to find NS RRset at $ww"); return; }
+    elsif (keys %s2g == 1) { zone_warning("only one nameserver at $ww"); }
+    @s= sort keys %s2g;
+    foreach $s (@s) {
+       @glue= @{ $s2g{$s} };
+       if (!@glue) {
+           zone_warning("glueless NS $s,".
+                        ($needglue<=1 ? " (eg)" : "").
+                        " from $ww")
+               unless $glueless_ok || !$needglue ||
+                      ($needglue<=1 && $warned_glueless{$s}++);
+           next;
        }
+       $glue= join ' ', sort @glue;
+       push @{ $glue{$s}{$glue} }, $ww;
+    }
+    $s= join ' ', @s;
+    $delgs_or_auths= $is_auth ? \%auths : \%delgs;
+    push @{ $delgs_or_auths->{$s} }, $ww;
+}
+
+sub zone_server_addr ($$$$$) {
+    my ($addr,$name,$ww,$wwq,$is_soa) = @_;
+    $addr_is_ok{$addr}= "$name ($wwq)"
+       if $is_soa || $cfg->{'s'} =~ m/u/;
+    zone_warning("configured as stealth but we [$addr]".
+                " are published ($name $wwq)")
+       if $cfg->{'s'} =~ m/u/ && grep { $_ eq $addr } @self_addr;
+
+    my ($name_is_self, $addr_is_self);
+    $name_is_self= grep { $_ eq $name }
+        @{ $cfg->{$is_soa ? 'self_soa' : 'self_ns'} };
+    $addr_is_self= grep { $_ eq $addr }
+        @{ $cfg->{'self_addr'} };
+    if ($name_is_self && !$addr_is_self) {
+       zone_warning("our name $name with wrong address [$addr], (eg) $ww")
+           unless $warned_mynameaddr{$name}{$addr}++;
+    } elsif (!$name_is_self && $addr_is_self) {
+       zone_warning(($is_soa ? "SOA ORIGIN maps to" : "allegedly served by").
+                    " us [$addr] with wrong name $name, (eg) $ww")
+           unless $warned_mynameaddr{$name}{$addr}++;
+    }
+    $delg_to_us=1 if $name_is_self;
+}
 
-       if ($style eq 'secondary') {
-           grep { $zone_ns=$_, grep { $myname eq $_ } @mynames } @zone_n
-               or warn "supposedly published secondary but we ".
-                       "(@mynames) are not published ($@zone_ns)\n";
+sub zone_check_soa ($$$) {
+    my ($uaddr,$ww,$wwq) = @_;
+    my ($lame,$origin,$got,$rcode,@soa_addrs,$soa_addr,$wwn);
+    verbose("checking service at $wwq");
+    $lame= 'dead or lame';
+    dig(sub {
+       if ($dig_type eq 'flags:') {
+           $lame= $dig_rdata =~ m/ aa / ? '' : 'lame';
+       } elsif ($dig_type eq 'soa' && $dig_owner eq $zone && !$lame) {
+           die "several SOAs ? $ww" if defined $origin;
+           $got= $dig_rdata;
+           $got =~ m/^(\S+) \d+/ or die "$got ?";
+           $origin= $1;
        }
+    },
+            $zone,'soa',$uaddr);
+    $lame= 'broken' if !$lame && !defined $origin;
+    if ($lame) { zone_warning("$lame server $ww"); return; }
+    push @{ $soas{$got} }, $ww;
+    ($rcode,@soa_addrs)= lookup($origin,'a','0');
+    foreach $soa_addr (@soa_addrs) {
+       $wwn= "SOA ORIGIN from $ww";
+       zone_server_addr($soa_addr,$origin,$wwn,"SOA [$uaddr]",1);
+       push @to_check, $soa_addr, "$origin, $wwn";
     }
-    check_after_eval();
-    
+}
 
-                        
-#      $superzone= $zone; $superzone =~ s/^[^\.]+\.//;
-#      @super_ns= lookup('ns-',$zone);
+sub zone_consistency() {
+    my ($d, $org_ser, $origin, $a, $h, $self_soa);
+    zone_consistency_set('delegations',\%delgs);
+    foreach $d (keys %delgs) { delete $auths{$d}; }
+    zone_consistency_set('zone nameserver rrset',\%auths);
+    foreach $h (keys %glue) {
+       zone_consistency_set("glue for $h", $glue{$h});
+    }
+    zone_consistency_set("SOA ORIGIN and SERIAL",\%soas);
+    $self_soa= $cfg->{'self_soa'};
+    if ($cfg->{'s'} =~ m/p/) {
+       foreach $org_ser (keys %soas) {
+           $org_ser =~ m/^(\S+) \d+$/ or die "$org_ser ?";
+           $origin= $1;
+           next if grep { $_ eq $origin } @$self_soa;
+           zone_warning("SOA ORIGIN $origin is not our name (@$self_soa),".
+                        " eg from ".($soas{$org_ser}[0]));
+       }
     }
+}
 
-    eval {
-
-       for $super_ns (@super_ns) {
-           @deleg_ns= ();
-           open DIG, "dig @$super_ns. -t ns +norecurse $zone."
-               or die "$0: fork for dig:\n $!\n";
-           while (<DIG>) {
-               
-
-           split /\n/, lookup("
-       
-               case "$style" in
-               secondary|backup)
-                       if [ $meadvert = 0 ]
-                       then
-                               warning "$myname unlisted NS $nsnames"
-                       fi
-                       ;;
-               unoff)
-                       if $meadvert = 0
-                       then
-                               warning "$myname advertised NS $nsnames"
-                       fi
-                       ;;
-               esac
-
-               addrs=''
-               for ns in $names
-               do
-                       set -e; a="`host -t a \"$ns\".`"; set +e
-                       taddrs="`echo \" $a\" | expand | sed -n '
-                                1s/^ //
-                               s/^[^ ][^ ]*  *A  *\([0-9][.0-9]*\)/\1/p
-                       '`"
-                       equlines "A $ns" "$a" "$taddrs"
-                       addrs="$addrs $taddrs"
-               done
-       fi
-
-       cat <<END
-zone "$zone" {
-       type slave;
-       file "$file";
-       masters {
-END
-       for server in $servers
-       do
-               echo "          $server;"
-               if $check
-               then
-                       notfound=1
-                       for addr in $addrs
-                       do
-                               if [ "x$addr" = "x$server" ]
-                               then
-                                       notfound=0
-                               fi
-                       done
-                       if $notfound
-                       then
- warning "server $server? but $rectype $names" $addrs
-                       fi
-               fi
-       done
-       cat <<END
-       };
-};
-END
-       hostfirstwarn=1
-       if $hostdelg
-       then
-               checkhostout -C
-       fi
-       if $hostzone
-       then
-               checkhostout -val localhost
-       fi
-done
-endfile
-
-    
-chdir "$base/primary" or die "$0: chdir $base/primary:\n $!";
-beginfile('primary.zones');
-
-for $f (<*_db>) {
-    $zone= $f; $zone =~ s/_db$//;
-    
-
-for f in $zones
-do
-       zone="`echo $f | sed -e 's/_db$//'`"
-       cat <<END
-zone "$zone" {
-       type master;
-       file "primary/$f";
-};
-END
-done
-endfile
+sub zone_servers_ok () {
+    my ($showok);
+    if (%addr_is_ok) {
+       $showok= 0;
+       foreach $a (@{ $cfg->{'servers'} }) {
+           next if exists $addr_is_ok{$a};
+           zone_warning("we slave from $a"); $showok=1;
+       }
+       if ($showok) {
+           foreach $a (keys %addr_is_ok) {
+               zone_warnmore("permitted master [$a] $addr_is_ok{$a}");
+           }
+       }
+    }
+    if ($cfg->{'s'} =~ m/s/ && !$delg_to_us) {
+       zone_warnmore("we are supposedly published secondary,".
+                     " but not listed as a nameserver");
+    }
+}
 
+sub zone_consistency_set ($%) {
+    my ($msg,$set) = @_;
+    my ($d,$o);
+    if (keys(%$set) > 1) {
+       zone_warning("inconsistent $msg:");
+       foreach $d (keys %$set) {
+           foreach $o (@{ $set->{$d} }) { zone_warnmore(" $d from $o"); }
+       }
+    }
+}
 
-    
-sub beginfile ($) {
-    $currentfile= $_[0];
-    $currentfile_opened= $install ? "$conf/$currentfile.new" : "/dev/null";
-    open CFF, "> $toopen" or die "$0: begin $currentfile_opened:\n $!\n";
+sub zone_check_local () {
+    zone_reset();
+    zone_servers_simplefind();
+    zone_servers_ok();
 }
 
-endfile () {
-    close CFF or die "$0: close $currentfile_opened:\n $!\n";
-    push @files, $currentfile;
+sub zone_servers_simplefind () {
+    my ($rcode,@nsnames,$ns,@soas,$origin);
+
+    ($rcode,@nsnames)= lookup($zone,'ns-','0');
+    foreach $ns (@nsnames) { zone_server_simple($ns,'NS',0); }
+
+    ($rcode,@soas)= lookup($zone,'soa','0');
+    die "multiple SOA RRs in set!  @soas ?" if @soas!=1;
+    $soas[0] =~ m/^(\S+)\s/ or die "SOA ? $_";
+    zone_server_simple(domain_canon($1),'SOA',1);
 }
 
-sub installfiles () {
-    return unless $install;
-    chdir $conf or die "$0: chdir $conf:\n $!\n";
-    for $f (@files) {
-       rename "$f.new", $f or die "$0: install new $f:\n $!\n";
-    }
+sub zone_server_simple ($$$) {
+    my ($name,$ww,$is_soa) = @_;
+    my ($rcode,@addrs,$addr);
+    ($rcode,@addrs)= lookup($name,'a','0');
+    foreach $addr (@addrs) { zone_server_addr($addr,$name,$ww,$ww,$is_soa); }
 }
 
-warning () {
-       echo >&2 "$zone $style: $*"
-       warnings=$[$warnings+1]
+#-------------------- outputting
+
+sub zone_output () {
+    $output_contents{$$cfg{'output'}}.=
+       sprintf(<<'END',
+zone "%s" {
+    type %s;
+    file "%s";
+};
+END
+               $zone,
+               $$cfg{'s'} =~ m/p/ ? 'master' : 'slave',
+               $$cfg{'file'});
 }
 
-equlines () {
-       if [ "x`echo \" $2\" | wc -l`" != "x`echo \" $3\" | wc -l`" ]
-       then
-               warning "$1 >$2|$3<"
-       fi
+
+#-------------------- general utilities
+
+sub debug_dump ($) {
+    my ($vn);
+    return unless $debug>1;
+    local $Data::Dumper::Terse=1;
+    foreach $vn (split /\s+/, $_[0]) {
+       print "$vn := ", eval "Dumper(\\$vn)";
+    }
 }
 
-checkhostout () {
-       set +e
-       hostout="`host $1 \"$zone\" 2>&1 >/dev/null $2 | egrep -v \
-'^ \!\!\! .* SOA primary .* is not advertised via NS$'`"
-       set -e
-       if [ "x$hostout" = x ]; then return; fi
-       if $hostfirstwarn
-       then
-               warning "warnings from host:"
-               hostfirstwarn=0
-       fi
-       echo >&2 "$hostout"
+sub debug_trace ($) {
+    return unless $debug;
+    print "D $_[0]\n";
 }
 
-progress () {
-       if $progress
-       then
-               echo -n "$zone $style                    " >&2
-               echo -ne '\r' >&2
-       fi
+sub lookup ($$$) {
+    my ($domain,$type,$okrcodes) = @_;
+    my ($c,$h,@result);
+    debug_trace("lookup ==> (->$okrcodes) $domain $type");
+    $h= new IO::Handle;
+
+    defined($c= open $h, "-|") or die "$quis: fork adnshost:\n $!\n";
+    if (!$c) {
+       exec 'adnshost','-Fi','+Do','+Dt','+Dc','-Cf',"-t$type",
+            '-',"$domain.";
+       die "$quis: exec adnshost:\n $!\n";
+    }
+    @result= $h->getlines();
+    $h->error and die "$quis: read from adnshost:\n $!\n";
+    chomp @result;
+    $!=0; $h->close;
+    die "$quis: lookup -t$type $domain $okrcodes failed $? $!\n"
+       if $! or $?>6 or index($okrcodes,$?)<0;
+    debug_trace("lookup <== $? @result");
+    return ($?,@result);
 }
 
-myname=''
 
-if [ $warnings != 0 ]
-then
-       echo >&2 "$warnings warnings                                        "
-fi
+sub dig (&$$$) {
+    my ($eachrr, $qowner,$qtype,$qaddr) = @_;
+    # also pseudo-rr with type `flags:'
+    my ($h,$inmid,$irdata,$c);
+    local ($_);
 
-installfiles
+    debug_trace("dig ==> \@$qaddr $qowner $qtype");
+
+    $h= new IO::Handle;
+    defined($c= open $h, "-|") or die "$quis: fork dig:\n $!\n";
+    if (!$c) {
+       open STDERR, ">&STDOUT" or die $!;
+       exec ('dig',
+             '+nodef','+nosea','+nodebug','+norecurse',
+             "\@$qaddr",'-t',$qtype,$qowner);
+       die "$quis: exec dig:\n $!\n";
+    }
+    $inmid='';
+    for (;;) {
+       if (!defined($_= $h->getline())) {
+           $h->error() and die "$quis: read from dig:\n $!\n";
+           last;
+       }
+       chomp;
+       if (length $inmid) {
+           s/^\s+/ / or die "$inmid // $_ ?";
+           s/\;.*$//;
+           $_= $inmid.$_;
+           $inmid='';
+           s/$/ \(/ unless s/\s*\)\s*$//;
+       }
+       if (s/\s*\(\s*$//) { $inmid= $_; next; }
+       if (m/^\;\; flags\:( [-0-9a-z ]+)\;/) {
+           $dig_owner=''; $dig_type='flags:'; $dig_rdata= "$1 ";
+           debug_trace("dig  f: $dig_rdata");
+           &$eachrr;
+       } elsif (m/^\;/) {
+       } elsif (!m/\S/) {
+       } elsif (m/^([-.0-9a-z]+)\s+\d\w+\s+in\s+([a-z]+)\s+(\S.*)/i) {
+           $dig_owner=domain_canon($1); $dig_type=lc $2; $irdata=$3;
+           if ($dig_type eq 'a') {
+               $irdata =~ m/^[.0-9]+$/ or die "$irdata ?";
+               $dig_rdata= $&;
+           } elsif ($dig_type eq 'ns') {
+               $irdata =~ m/^[-.0-9a-z]+$/i or die "bad nameserver $irdata ?";
+               $dig_rdata= domain_canon($irdata);
+           } elsif ($dig_type eq 'soa') {
+               $irdata =~ m/^([-.0-9a-z]+)\s+.*\s+(\d+)(?:\s+\d\w+){4}$/i
+                   or die "bad SOA $irdata ?";
+               $dig_rdata= domain_canon($1).' '.$2;
+           } else {
+               debug_trace("ignoring uknown RR type $dig_type");
+               next;
+           }
+           debug_trace("dig  $dig_owner $dig_type $dig_rdata");
+           &$eachrr;
+       } else {
+           debug_trace("ignoring unknown dig output $_");
+       }
+    }
+    $h->close;
+    debug_trace("dig <== gave $?");
+}
+
+sub domain_canon ($) {
+    local ($_) = @_;
+    s/(.)\.$/$1/;
+    die "domain $_ ?" unless m/^[0-9a-z]/i;
+    return lc $_;
+}